// Classification with known components
// -------------------------------------
clc, clear, close(winsid()), mode(0), getd()

nd=100;
k=[1 5];
for t=1:nd
  c(t)=sum(cumsum([.4 .6])<rand(1,1,'u'))+1;
  y(t)=k(c(t))+rand(1,1,'n');
  
  for j=1:2
    q(j)=GaussN(y(t),k(j),1);
  end
  w(:,t)=q/sum(q);
  [nill cp(t)]=max(w(:,t));
end

disp 'Accuracy of classification'
acc=sum(c==cp)/nd

set(scf(1),'position',[600 0 600 300])
plot(1:nd,c,'.:',1:nd,cp,'x:')
legend('c','cp');
title 'Pointer and its estimate'
