// Classification with unknown components
// -------------------------------------
clc, clear, close(winsid()), mode(0), getd()

nd=100;
k=[1 5];
kE=[3 4];
ka=[1 1];
S=kE.*ka;
for t=1:nd
  c(t)=sum(cumsum([.4 .6])<rand(1,1,'u'))+1;
  y(t)=k(c(t))+rand(1,1,'n');
  
  for j=1:2
    q(j)=GaussN(y(t),kE(j),1);
  end
  w(:,t)=q/sum(q);
  [nill cp(t)]=max(w(:,t));
  for j=1:2
    S=S+w(j,t)*y(t);
    ka=ka+w(j,t);
    kE(j)=S(j)/ka(j);
  end
end

disp 'Accuracy of classification'
acc=sum(c==cp)/nd

set(scf(1),'position',[600 0 600 300])
plot(1:nd,c,'.:',1:nd,cp,'x:')
legend('c','cp');
title 'Pointer and its estimate'
