function x=cut01(x)
  // cutting columns of matrix to interval(0,1)
  n=size(x,2);
  for i=1:n
  //  s=find(x(:,i)>1);
  //  x(s,i)=1;
    r=find(x(:,i)<0);
    x(r,i)=0;
    clear s r
  end
endfunction
function fn=fnorm(f,i)
  // fn=fnorm(f,i)   normalization of probabilistic table             
  // fn  normalized table
  // f   table
  // i   direction i=1 norm colunms, i=2 norm rows
  // Rem: f can have zero rows or columns
  // cuts the values >1 or <0

  if argn(2)==1, 
    [m,n]=size(f);
    f=cut01(f);
    sf=sum(f);
    if sf==0
      fn=ones(f)/length(f);
    else
      fn=f/sf; 
    end
  else
    [m n]=size(f);
    if i==1
      f=cut01(f);
      f1=sum(f,1);
      s=find(f1==0);
      f1(s)=m;
      f(:,s)=ones(m,length(s));
      fn=f./(ones(m,1)*f1);
    else
      f=cut01(f')';
      f2=sum(f,2);
      s=find(f2==0);
      f2(s)=n;
      f(s,:)=ones(length(s),n);
      fn=f./(f2*ones(1,n));
    end
  end
endfunction
