// Conditional mix
// - both x and y are in clusters
// ------------------------------------------
clc, clear, close, mode(0)
getd c:\functions

nd=500;
a=list();
a(1)=[5 -1 0];
a(2)=[1 6 -1];
a(3)=[2 -1 8];
al=[.3 .5 .2];
for t=1:nd
  c(t)=(sum(randu(1,1)>cumsum(al)))+1;
  x(t,:)=a(c(t))+.3*randn(1,3);
  y(t)=a(c(t))*x(t,:)'+.1*randn(1,1);
end
nc=length(a);

V=list(); th=list(); aI=list(); //tt=list();

aI(1)=[6 0 0];
aI(2)=[0 5 0];
aI(3)=[0 0 7];
ka=ones(1,nc);
for j=1:nc
  V(j)=eye(4,4); V(j)(2:$,1)=aI(j)'; V(j)(1,2:$)=aI(j); 
  th(j)=v2thN(V(j)/ka(j),1);
end
t1=th(1); t2=th(2); t3=th(3);
//pause
for t=1:nd
  for j=1:nc
    [nill,qL(j)]=GaussN(y(t),x(t,:)*th(j),.1);
  end
  qp=qL-max(qL); q=exp(qp);  //pause
  w=fnorm(q);
  wt(:,t)=w;
  for j=1:nc
    V(j)=V(j)+w(j)*[y(t) x(t,:)]'*[y(t) x(t,:)];
    ka(j)=ka(j)+w(j);
    th(j)=v2thN(V(j)/ka(j),1); 
    t1=[t1 th(1)]; t2=[t2 th(2)]; t3=[t3 th(3)];
  end
end
[nill,cp]=max(wt,'r');

scf(); 
plot(t1(1,:),t1(2,:),'.:')
plot(t2(1,:),t2(2,:),'.:')
plot(t3(1,:),t3(2,:),'.:')
for i=1:3
plot(aI(i)(1),aI(i)(2),'ko','markersize',8)
plot(a(i)(1),a(i)(2),'kx','markersize',14)
plot(a(i)(1),a(i)(2),'ko','markersize',14)
end

