// Estimation of a coin with prior information
// ------------------------------------------
clc, clear, close, mode(0) 
rand('seed',0);

p=.2;
x=(rand(1,100,'u')<(1-p))+1;
p0=.8; ka=0;
S=[p0 1-p0]*ka
//S=[100 100];
for t=1:length(x)
  S(x(t))=S(x(t))+1;
  th(t,:)=S/sum(S);
end
set(scf(),'position',[800 380 500 300]);
plot(th(:,1),'.:')
set(gca(),'data_bounds',[1 length(x) 0 1]);
disp('Final estimate',th($,1))
