// Estimation of reg. model with prior information
//   y(t)=ay(t-1)+bu(t)+k+e(t)
// ------------------------------------------
clc, clear, close, mode(0)

nd=500;
a=.6; b=1; k=3; sd=1;
u=rand(1,nd,'n')+1;
y(1)=0; th=[];
aI=.1; bI=.1; kI=4;
ka=10; //.0001;
V=[1 aI bI kI
   aI 1  0 0
   bI 0  1 0
   kI 0  0 1]*ka;
for t=2:nd
  y(t)=a*y(t-1)+b*u(t)+k+sd*rand(1,1,'n');

  Ps=[y(t) y(t-1) u(t) 1]';
  V=V+Ps*Ps';
  ka=ka+1;
  
  th(t,:)=inv(V(2:$,2:$))*V(2:$,1);
end
set(scf(),'position',[800 380 500 300]);
plot(th(:,1),'.:')
set(gca(),'data_bounds',[1 length(y) 0 1]);
title 'Evolution of the estimate of a'
disp('Final estimate',th($,1))
