// Zero-step prediction with categorical model
//   f(y(t)|u(t),y(t-1))
// -------------------------------------
clc, clear, close, mode(0)

nd=20;
th=[.9 .1 .1 .9
    .1 .9 .9 .1];

// simulation
y(1)=1;
for t=2:nd
  u(t)=sum(cumsum([.4 .6])<rand(1,1,'u'))+1;
  i=2*(u(t)-1)+y(t-1);
  y(t)=sum(cumsum(th(:,i))<rand(1,1,'u'))+1;
end

// prediction
yp(1)=1;
for t=2:nd
  i=2*(u(t)-1)+y(t-1);
  yp(t)=sum(cumsum(th(:,i))<rand(1,1,'u'))+1;
end

plot(1:nd,y,'x:',1:nd,yp,'.:','markersize',8)
title 'Discrete signal and its prediction'
