function [c,m]=condf(f,i)
  // conditional and marginal from the joint f
  // c    conditional
  // m    marginal
  // i=1: marginal is row; conditional normed columns
  // i=2: marginal is column; conditional normed rows   
  if argn(2)<2, i=1; end
  [n1,n2]=size(f);
  select i
  case 1;
    m=sum(f,1);
    c=f./(ones(n1,1)*m);
  case 2
    m=sum(f,2);
    c=f./(m*ones(1,n2));
  end
endfunction
  
